package nl.naturalis.nba.etl.geo;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

import java.util.List;
import java.util.UUID;
import nl.naturalis.nba.api.model.GeoArea;
import nl.naturalis.nba.api.model.SourceSystem;
import nl.naturalis.nba.dao.DocumentType;
import nl.naturalis.nba.etl.AbstractTransformer;
import nl.naturalis.nba.etl.CSVRecordInfo;
import nl.naturalis.nba.etl.ETLStatistics;
import nl.naturalis.nba.etl.report.Report;
import nl.naturalis.nba.etl.utils.CommonReflectionUtil;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 * Test class for GeoTransformer.java
 *
 */
@SuppressWarnings({"unchecked"})
public class GeoTransformerTest {

  /**
   * @throws java.lang.Exception
   */
  @Before
  public void setUp() throws Exception {}

  /**
   * @throws java.lang.Exception
   */
  @After
  public void tearDown() throws Exception {}

  /**
   * Test method for {@link nl.naturalis.nba.etl.geo.GeoTransformer#doTransform()}.
   *
   * Test to verify the do Transform object returns the correct {@List<GeoArea>} object
   *
   * @throws Exception
   */
  @Test
  public void testDoTransform() throws Exception {

    CSVRecordInfo<GeoCsvField> record = mock(CSVRecordInfo.class);
    String jobId = UUID.randomUUID().toString();
    Report report = new Report(jobId, SourceSystem.GEO, DocumentType.GEO_AREA);
    ETLStatistics etlStatistics = new ETLStatistics();

    String geoJson =
        "{\"type\":\"MultiPolygon\",\"coordinates\":[[[[167.544688347,-22.598239842],[167.554698113,-22.612237238],[167.555186394,-22.638441665],[167.542979363,-22.630140883],[167.530935092,-22.60556406],[167.521006707,-22.603692316],[167.516123894,-22.611260675],[167.516612175,-22.624118748],[167.521006707,-22.648695571],[167.507334832,-22.670668227],[167.475840691,-22.667087498],[167.418711785,-22.645277602],[167.424001498,-22.620293878],[167.42448978,-22.561700128],[167.43230228,-22.542250258],[167.450205925,-22.538018488],[167.476898634,-22.543389581],[167.503428582,-22.554945571],[167.521006707,-22.569594008],[167.531504754,-22.587090753],[167.544688347,-22.598239842]]],[[[166.843435092,-22.424411717],[166.840586785,-22.431247654],[166.835703972,-22.432061456],[166.828949415,-22.42555104],[166.821299675,-22.431410415],[166.815765821,-22.434828383],[166.801768425,-22.439873956],[166.801768425,-22.445977472],[166.820974155,-22.448825779],[166.818858269,-22.455824477],[166.808116082,-22.462334894],[166.801768425,-22.463067316],[166.794444207,-22.460544529],[166.78028405,-22.457614842],[166.770762566,-22.450616144],[166.777679884,-22.436455988],[166.785166863,-22.424737238],[166.786387566,-22.415134373],[166.789398634,-22.406670831],[166.801768425,-22.398858331],[166.814789259,-22.395114842],[166.825450066,-22.395684503],[166.834320509,-22.401462498],[166.843272332,-22.412530206],[166.843435092,-22.424411717]]],[[[171.343765287,-22.346341598],[171.341921762,-22.349238565],[171.339024795,-22.347658402],[171.340604959,-22.344761435],[171.343765287,-22.346341598]]],[[[167.971934441,-21.375258071],[167.966644727,-21.39430104],[167.971934441,-21.411228123],[167.983653191,-21.429375909],[167.997325066,-21.444594008],[168.007660352,-21.45289479],[168.038747592,-21.459730727],[168.074473504,-21.455743097],[168.109222852,-21.445000909],[168.137461785,-21.431817316],[168.144216342,-21.452732029],[168.143728061,-21.488702081],[168.136485222,-21.5272763],[168.12378991,-21.555352472],[168.129079623,-21.60133229],[168.126800977,-21.622247003],[168.114105665,-21.631036066],[168.101898634,-21.632989191],[168.064219597,-21.642998956],[168.035411004,-21.658461196],[167.992930535,-21.654961847],[167.958181186,-21.638441665],[167.95997155,-21.610609633],[167.938975457,-21.60165781],[167.912608269,-21.595635675],[167.8857528,-21.595391534],[167.863617384,-21.603692316],[167.861175977,-21.600681248],[167.859222852,-21.597344659],[167.857758009,-21.59384531],[167.856781446,-21.589532159],[167.867442254,-21.582777602],[167.879893425,-21.572686456],[167.88949629,-21.559014581],[167.891612175,-21.541680597],[167.886403842,-21.533461196],[167.863942905,-21.510674738],[167.856781446,-21.500746352],[167.850840691,-21.482842706],[167.847911004,-21.456231378],[167.843923373,-21.439222915],[167.836110873,-21.422621352],[167.808441602,-21.383965753],[167.82300866,-21.377048435],[167.835948113,-21.374281508],[167.848806186,-21.37476979],[167.863617384,-21.377211196],[167.889170769,-21.388604425],[167.90495853,-21.392754816],[167.922211134,-21.378187758],[167.987803582,-21.335625909],[167.990407748,-21.348728123],[167.971934441,-21.375258071]]],[[[166.458506707,-20.719903253],[166.453379754,-20.728936456],[166.443532748,-20.733493748],[166.418142123,-20.740411066],[166.412608269,-20.735121352],[166.407399936,-20.731540623],[166.400645379,-20.728936456],[166.390879754,-20.726739191],[166.398448113,-20.721937758],[166.406423373,-20.719659113],[166.415212436,-20.719008071],[166.424978061,-20.719903253],[166.432953321,-20.719008071],[166.458506707,-20.719903253]]],[[[167.301280144,-20.713067316],[167.308278842,-20.730889581],[167.300466342,-20.748142185],[167.28793379,-20.76555755],[167.281504754,-20.784437758],[167.282237175,-20.796319269],[167.288340691,-20.822360935],[167.301280144,-20.849704685],[167.297536655,-20.862237238],[167.284353061,-20.882256769],[167.281504754,-20.89430104],[167.284678582,-20.901788019],[167.292491082,-20.905694269],[167.302500847,-20.909112238],[167.312266472,-20.914808852],[167.322520379,-20.923760675],[167.3310653,-20.92945729],[167.356700066,-20.938409113],[167.368418816,-20.939548435],[167.378184441,-20.939060154],[167.38550866,-20.941664321],[167.390798373,-20.952732029],[167.394379102,-20.957696222],[167.400401238,-20.967950128],[167.40503991,-20.97242604],[167.393890821,-20.989922784],[167.390391472,-20.999444269],[167.390798373,-21.00790781],[167.399180535,-21.019219659],[167.409841342,-21.02320729],[167.421397332,-21.024509373],[167.43230228,-21.027764581],[167.444834832,-21.036797784],[167.459483269,-21.05087656],[167.464691602,-21.063653253],[167.431813998,-21.074883722],[167.425303582,-21.089125258],[167.425466342,-21.127373956],[167.423350457,-21.147556248],[167.4170028,-21.1600888],[167.406097852,-21.169040623],[167.390798373,-21.178643488],[167.37387129,-21.17180755],[167.351084832,-21.17180755],[167.3310653,-21.16415781],[167.322438998,-21.134209894],[167.314952019,-21.129571222],[167.298594597,-21.127373956],[167.282074415,-21.123467706],[167.274668816,-21.113702081],[167.272959832,-21.096937758],[167.267588738,-21.091485284],[167.176036004,-21.082207941],[167.146332227,-21.073011977],[167.1201278,-21.051934503],[167.09644616,-21.027764581],[167.093923373,-21.020765883],[167.092295769,-21.0116513],[167.088389519,-21.0038388],[167.067393425,-20.996351821],[167.06153405,-20.986260675],[167.062022332,-20.973077081],[167.068614129,-20.959567967],[167.028493686,-20.925388279],[167.020843946,-20.911716404],[167.082204623,-20.916192316],[167.102712436,-20.911716404],[167.121592644,-20.901543878],[167.133474155,-20.890069269],[167.15113366,-20.8632138],[167.181162957,-20.829847915],[167.190928582,-20.809991144],[167.185313347,-20.788181248],[167.172862175,-20.781426691],[167.1201278,-20.760186456],[167.044444207,-20.768243097],[167.042491082,-20.758558852],[167.047048373,-20.737237238],[167.058848504,-20.715997003],[167.079112175,-20.706231378],[167.113129102,-20.701104425],[167.1201278,-20.702813409],[167.126963738,-20.708672784],[167.134287957,-20.711683852],[167.143077019,-20.712985935],[167.154307488,-20.713067316],[167.164317254,-20.710137628],[167.171885613,-20.702569269],[167.176768425,-20.692559503],[167.17847741,-20.682061456],[167.212575717,-20.672133071],[167.28777103,-20.711521092],[167.301280144,-20.713067316]]],[[[166.623545769,-20.400648696],[166.629649285,-20.413750909],[166.637217644,-20.425062758],[166.648285352,-20.432793878],[166.673350457,-20.445733331],[166.678233269,-20.452406508],[166.673838738,-20.463636977],[166.66309655,-20.467380467],[166.633474155,-20.465997003],[166.620778842,-20.469333592],[166.611338738,-20.477227472],[166.605723504,-20.487399998],[166.603770379,-20.497165623],[166.600922071,-20.49993255],[166.585703972,-20.538018488],[166.579274936,-20.549574477],[166.578623894,-20.564873956],[166.582041863,-20.592950128],[166.587657097,-20.599867446],[166.600922071,-20.600192967],[166.629730665,-20.596368097],[166.591481967,-20.665134373],[166.575205925,-20.685153904],[166.559580925,-20.69508229],[166.537282748,-20.704685154],[166.513519727,-20.711521092],[166.493907097,-20.713067316],[166.485850457,-20.706231378],[166.479665561,-20.699395441],[166.4951278,-20.693454685],[166.508962436,-20.6835263],[166.5341903,-20.658461196],[166.550791863,-20.637139581],[166.558278842,-20.624444269],[166.56137129,-20.606622003],[166.559580925,-20.545668227],[166.564952019,-20.531508071],[166.576508009,-20.517266534],[166.5888778,-20.497653904],[166.598887566,-20.476739191],[166.603770379,-20.458591404],[166.599375847,-20.439629816],[166.580332879,-20.414727472],[166.571462436,-20.405938409],[166.567230665,-20.407321873],[166.56137129,-20.410821222],[166.563731316,-20.401950779],[166.574554884,-20.392347915],[166.589528842,-20.385430597],[166.603770379,-20.383477472],[166.61597741,-20.389418227],[166.623545769,-20.400648696]]],[[[164.013519727,-20.083103123],[164.032237175,-20.09384531],[164.051768425,-20.10930755],[164.067393425,-20.126071873],[164.077403191,-20.149834894],[164.086761915,-20.155450128],[164.109141472,-20.164971613],[164.182953321,-20.247328383],[164.19792728,-20.260511977],[164.244313998,-20.285332941],[164.26433353,-20.288669529],[164.286631707,-20.28101979],[164.292816602,-20.28101979],[164.305918816,-20.308770441],[164.316579623,-20.319105727],[164.334483269,-20.321465753],[164.325450066,-20.309177342],[164.310883009,-20.275160415],[164.304372592,-20.242771092],[164.306488477,-20.235039972],[164.315765821,-20.234795831],[164.495616082,-20.300225519],[164.527517123,-20.326592706],[164.58082116,-20.390883071],[164.595225457,-20.403578383],[164.615244988,-20.417087498],[164.636241082,-20.427504165],[164.653493686,-20.431817316],[164.684580925,-20.458591404],[164.694834832,-20.463067316],[164.72543379,-20.472832941],[164.739756707,-20.485528253],[164.767751498,-20.520765883],[164.783213738,-20.528090102],[164.79175866,-20.5350888],[164.827810092,-20.582696222],[164.879649285,-20.626560154],[164.88941491,-20.627373956],[164.919769727,-20.645114842],[164.935231967,-20.659112238],[164.930349155,-20.672133071],[164.94792728,-20.68368906],[164.988536004,-20.685316665],[165.005544467,-20.699395441],[165.024424675,-20.705743097],[165.06153405,-20.734063409],[165.167165561,-20.754082941],[165.170176629,-20.756036066],[165.178233269,-20.765313409],[165.184092644,-20.768243097],[165.187510613,-20.767022394],[165.192556186,-20.763604425],[165.198578321,-20.760511977],[165.205251498,-20.760186456],[165.21753991,-20.764418227],[165.222015821,-20.767998956],[165.225108269,-20.772881769],[165.232676629,-20.780694269],[165.25684655,-20.800062758],[165.26441491,-20.813246352],[165.259938998,-20.828545831],[165.270030144,-20.869561456],[165.280446811,-20.883884373],[165.29558353,-20.894219659],[165.311045769,-20.902601821],[165.3232528,-20.912774347],[165.328298373,-20.928399347],[165.336680535,-20.931573175],[165.38965905,-20.938409113],[165.407725457,-20.943942967],[165.41309655,-20.9491513],[165.40886478,-20.982517185],[165.402517123,-21.005059503],[165.399912957,-21.011000258],[165.395518425,-21.018243097],[165.39714603,-21.024834894],[165.40113366,-21.03134531],[165.403330925,-21.038262628],[165.406748894,-21.055433852],[165.415049675,-21.0663388],[165.44809004,-21.089532159],[165.476247592,-21.103773696],[165.489268425,-21.113702081],[165.502207879,-21.127129816],[165.509776238,-21.129978123],[165.535655144,-21.131524347],[165.542979363,-21.134698175],[165.544932488,-21.141208592],[165.541026238,-21.151950779],[165.546885613,-21.149672133],[165.54948978,-21.149183852],[165.551280144,-21.148125909],[165.554860873,-21.1444638],[165.585459832,-21.168389581],[165.598643425,-21.181735935],[165.602549675,-21.192152602],[165.607758009,-21.19540781],[165.610524936,-21.198337498],[165.615407748,-21.206475519],[165.598643425,-21.206231378],[165.583262566,-21.202325128],[165.568858269,-21.195489191],[165.554860873,-21.186130467],[165.559255405,-21.195570571],[165.568614129,-21.2069638],[165.580577019,-21.216241144],[165.592295769,-21.220147394],[165.602549675,-21.22649505],[165.610118035,-21.241143488],[165.616465691,-21.257256769],[165.623057488,-21.267998956],[165.646250847,-21.277601821],[165.706553582,-21.292168878],[165.72535241,-21.309502863],[165.754405144,-21.302341404],[165.781260613,-21.31617604],[165.801117384,-21.340264581],[165.808604363,-21.363539321],[165.826182488,-21.359633071],[165.836680535,-21.402032159],[165.856293165,-21.418715102],[165.845876498,-21.398858331],[165.844899936,-21.391371352],[165.849619988,-21.383965753],[165.858734571,-21.3788388],[165.868174675,-21.379164321],[165.876800977,-21.385430597],[165.883636915,-21.397719008],[165.889170769,-21.388848566],[165.890391472,-21.378024998],[165.886403842,-21.366794529],[165.876149936,-21.356703383],[165.894053582,-21.361097915],[165.908376498,-21.378024998],[165.943125847,-21.438734633],[165.949880405,-21.455743097],[165.945323113,-21.464288019],[165.924082879,-21.459730727],[165.931325717,-21.470147394],[165.972341342,-21.493829034],[165.966481967,-21.503024998],[165.974457227,-21.50400156],[165.986664259,-21.500746352],[165.992930535,-21.497247003],[165.990407748,-21.48447031],[165.984548373,-21.475030206],[165.977712436,-21.467380467],[165.972341342,-21.459730727],[165.964040561,-21.435804946],[165.961924675,-21.417413019],[165.969411655,-21.410414321],[165.989512566,-21.421563409],[166.020274285,-21.45289479],[166.030609571,-21.455661717],[166.055430535,-21.458591404],[166.064626498,-21.463148696],[166.066742384,-21.469903253],[166.059743686,-21.473077081],[166.051036004,-21.475355727],[166.048187696,-21.479668878],[166.052500847,-21.483982029],[166.059255405,-21.485935154],[166.068044467,-21.487074477],[166.070485873,-21.497653904],[166.072276238,-21.516208592],[166.074880405,-21.528008722],[166.097992384,-21.517347915],[166.116465691,-21.517266534],[166.133148634,-21.525974217],[166.184743686,-21.569594008],[166.190928582,-21.572686456],[166.204112175,-21.576104425],[166.208832227,-21.579522394],[166.218760613,-21.596937758],[166.253916863,-21.618747654],[166.291026238,-21.635430597],[166.370371941,-21.658949477],[166.370371941,-21.665215753],[166.34245853,-21.665215753],[166.34245853,-21.672051691],[166.349619988,-21.676527602],[166.351817254,-21.682305597],[166.353037957,-21.688246352],[166.356700066,-21.693129165],[166.363291863,-21.695977472],[166.376963738,-21.697035415],[166.411306186,-21.705498956],[166.425547722,-21.712334894],[166.437022332,-21.731540623],[166.475840691,-21.758396092],[166.480235222,-21.76539479],[166.483653191,-21.783461196],[166.489756707,-21.792168878],[166.495778842,-21.796075128],[166.513682488,-21.802992446],[166.506195509,-21.809258722],[166.529144727,-21.82789479],[166.573415561,-21.87493255],[166.59253991,-21.884372654],[166.610606316,-21.897637628],[166.637461785,-21.923435154],[166.661387566,-21.939629816],[166.671234571,-21.925225519],[166.7060653,-21.948011977],[166.719086134,-21.952569269],[166.719086134,-21.960056248],[166.711436394,-21.96493906],[166.703298373,-21.96868255],[166.694509311,-21.971368097],[166.685069207,-21.973077081],[166.685069207,-21.98056406],[166.693207227,-21.984063409],[166.722504102,-21.98056406],[166.735524936,-21.983168227],[166.746104363,-21.98805104],[166.754242384,-21.990817967],[166.760020379,-21.986748956],[166.767344597,-22.004815363],[166.778330925,-22.014580988],[166.794200066,-22.019138279],[166.8154403,-22.021579685],[166.87370853,-22.0350888],[166.887950066,-22.042575779],[166.938812696,-22.079847915],[166.9482528,-22.092054946],[166.959320509,-22.110935154],[166.960785352,-22.119235935],[166.959320509,-22.144952081],[166.955251498,-22.150648696],[166.9482528,-22.157810154],[166.94800866,-22.163669529],[166.962738477,-22.166110935],[166.97152754,-22.170179946],[166.979746941,-22.180108331],[166.993418816,-22.200290623],[167.028819207,-22.226820571],[167.034434441,-22.237481378],[167.031748894,-22.246677342],[167.025563998,-22.248142185],[167.01832116,-22.248467706],[167.013438347,-22.254815363],[167.015798373,-22.261163019],[167.02214603,-22.268243097],[167.027110222,-22.276462498],[167.023936394,-22.285577081],[167.020518425,-22.292168878],[167.013438347,-22.3163388],[167.005869988,-22.329766534],[167.000743035,-22.336683852],[166.993418816,-22.344333592],[166.991547071,-22.339532159],[166.988536004,-22.335056248],[166.982676629,-22.337579034],[166.977549675,-22.342461847],[166.965586785,-22.347263279],[166.960785352,-22.350762628],[166.961924675,-22.355889581],[166.966156446,-22.364678644],[166.934580925,-22.388441665],[166.915700717,-22.395603123],[166.890961134,-22.392022394],[166.911631707,-22.385023696],[166.919688347,-22.380059503],[166.925303582,-22.37086354],[166.909841342,-22.371270441],[166.903086785,-22.373304946],[166.895274285,-22.364922784],[166.889821811,-22.351983331],[166.88160241,-22.337660415],[166.877452019,-22.333672784],[166.874278191,-22.322035415],[166.867930535,-22.329278253],[166.861827019,-22.343031508],[166.860036655,-22.350518488],[166.851817254,-22.346449477],[166.84652754,-22.337090753],[166.841807488,-22.325860284],[166.835785352,-22.3163388],[166.840179884,-22.315118097],[166.849457227,-22.310153904],[166.840342644,-22.297946873],[166.831390821,-22.30087656],[166.824717644,-22.314222915],[166.820974155,-22.343031508],[166.81918379,-22.348077081],[166.818858269,-22.353610935],[166.822276238,-22.364678644],[166.825043165,-22.365980727],[166.843272332,-22.378350519],[166.832286004,-22.380791925],[166.818532748,-22.378594659],[166.806651238,-22.375176691],[166.801768425,-22.374688409],[166.799082879,-22.379815363],[166.792735222,-22.385511977],[166.784841342,-22.390069269],[166.777679884,-22.392022394],[166.75261478,-22.3866513],[166.739268425,-22.374281508],[166.740570509,-22.360446873],[166.760020379,-22.350518488],[166.760020379,-22.344333592],[166.741953972,-22.346123956],[166.719981316,-22.34384531],[166.7060653,-22.334730727],[166.712250196,-22.3163388],[166.705577019,-22.310153904],[166.690603061,-22.315118097],[166.667491082,-22.307224217],[166.646494988,-22.29273854],[166.637217644,-22.278741144],[166.632823113,-22.276950779],[166.610036655,-22.286309503],[166.599619988,-22.28899505],[166.591644727,-22.287204685],[166.566579623,-22.27711354],[166.557953321,-22.271905206],[166.554453972,-22.262139581],[166.56120853,-22.256524347],[166.565684441,-22.250664972],[166.554535352,-22.240655206],[166.54558353,-22.237562758],[166.516286655,-22.233575128],[166.506195509,-22.23447031],[166.4951278,-22.249118748],[166.488291863,-22.271416925],[166.478363477,-22.287204685],[166.458506707,-22.282159113],[166.458262566,-22.286228123],[166.457774285,-22.288018488],[166.4560653,-22.288669529],[166.452321811,-22.28899505],[166.460134311,-22.307712498],[166.449880405,-22.31243255],[166.436696811,-22.308038019],[166.434743686,-22.299248956],[166.437673373,-22.290622654],[166.439300977,-22.265232029],[166.446055535,-22.254815363],[166.446055535,-22.248142185],[166.431407097,-22.248955988],[166.418142123,-22.245700779],[166.406748894,-22.23837656],[166.397634311,-22.226820571],[166.430023634,-22.228122654],[166.44410241,-22.224379165],[166.452321811,-22.213962498],[166.434255405,-22.212985935],[166.428233269,-22.204278253],[166.431813998,-22.172295831],[166.421885613,-22.173028253],[166.400238477,-22.169691665],[166.390879754,-22.172295831],[166.387543165,-22.178155206],[166.383311394,-22.196384373],[166.380544467,-22.200290623],[166.367930535,-22.202080988],[166.363047722,-22.20712656],[166.360118035,-22.214532159],[166.353282097,-22.223809503],[166.344004754,-22.227471613],[166.339366082,-22.221368097],[166.340993686,-22.210625909],[166.349864129,-22.200290623],[166.339610222,-22.194431248],[166.31511478,-22.172295831],[166.31511478,-22.166110935],[166.321543816,-22.162774347],[166.324880405,-22.159112238],[166.32683353,-22.153497003],[166.328135613,-22.144952081],[166.321950717,-22.144952081],[166.312022332,-22.154717706],[166.285899285,-22.149346613],[166.28777103,-22.158623956],[166.268728061,-22.165785415],[166.252126498,-22.15992604],[166.236175977,-22.151788019],[166.218760613,-22.151788019],[166.217946811,-22.13274505],[166.208832227,-22.117771092],[166.195323113,-22.107679946],[166.181325717,-22.104099217],[166.168955925,-22.0975888],[166.157481316,-22.086683852],[166.145274285,-22.084567967],[166.130137566,-22.104099217],[166.119313998,-22.098077081],[166.108897332,-22.090427342],[166.113536004,-22.085219008],[166.11589603,-22.079847915],[166.116547071,-22.072686456],[166.116465691,-22.06243255],[166.122731967,-22.06243255],[166.131114129,-22.071465753],[166.142100457,-22.075860284],[166.150401238,-22.071954034],[166.150645379,-22.056247654],[166.144541863,-22.046563409],[166.125010613,-22.038506769],[166.116465691,-22.028415623],[166.143728061,-22.028578383],[166.15503991,-22.030694269],[166.164317254,-22.0350888],[166.163340691,-22.024590753],[166.15894616,-22.018324477],[166.15121504,-22.01539479],[166.140391472,-22.014743748],[166.135264519,-22.008558852],[166.136892123,-21.995538019],[166.140961134,-21.983575128],[166.143809441,-21.98056406],[166.1357528,-21.958265883],[166.123057488,-21.948825779],[166.08855228,-21.938897394],[166.076426629,-21.945896092],[166.069997592,-21.943047784],[166.071299675,-21.934828383],[166.082286004,-21.925225519],[166.071787957,-21.920505467],[166.064463738,-21.913018488],[166.060720248,-21.903252863],[166.06120853,-21.891208592],[166.04558353,-21.900648696],[166.039886915,-21.90992604],[166.040782097,-21.935479425],[166.036143425,-21.941582941],[166.025563998,-21.94150156],[166.014008009,-21.939385675],[166.00660241,-21.938897394],[166.01042728,-21.943780206],[166.009613477,-21.955824477],[166.003184441,-21.963962498],[165.989512566,-21.956312758],[165.975108269,-21.937676691],[165.965993686,-21.928887628],[165.934906446,-21.91773854],[165.914317254,-21.884942316],[165.899912957,-21.877536717],[165.893077019,-21.875746352],[165.88550866,-21.871351821],[165.872813347,-21.861016534],[165.866709832,-21.857842706],[165.861582879,-21.859633071],[165.856211785,-21.8632138],[165.849619988,-21.864434503],[165.820567254,-21.863946222],[165.810883009,-21.858575128],[165.808604363,-21.843357029],[165.829600457,-21.852146092],[165.82292728,-21.842217706],[165.794932488,-21.816664321],[165.794932488,-21.808851821],[165.799164259,-21.799574477],[165.800303582,-21.792087498],[165.791270379,-21.788750909],[165.780772332,-21.791110935],[165.776621941,-21.797133071],[165.777110222,-21.806084894],[165.780772332,-21.816664321],[165.764008009,-21.811211847],[165.76059004,-21.799899998],[165.761973504,-21.7850888],[165.759532097,-21.768812758],[165.751149936,-21.758721613],[165.740733269,-21.750258071],[165.732920769,-21.738946222],[165.732920769,-21.719821873],[165.72535241,-21.719821873],[165.717295769,-21.735528253],[165.706879102,-21.748304946],[165.693858269,-21.757419529],[165.677744988,-21.761407159],[165.67855879,-21.740899347],[165.677500847,-21.729424738],[165.669932488,-21.725274347],[165.650889519,-21.726739191],[165.650238477,-21.728936456],[165.650645379,-21.733656508],[165.649424675,-21.738457941],[165.64340254,-21.740899347],[165.637950066,-21.740166925],[165.504567905,-21.678155206],[165.473887566,-21.651788019],[165.485850457,-21.631036066],[165.485850457,-21.623630467],[165.47152754,-21.628513279],[165.463145379,-21.625909113],[165.464610222,-21.620538019],[165.479014519,-21.616875909],[165.463145379,-21.605645441],[165.446543816,-21.60930755],[165.429860873,-21.618584894],[165.413422071,-21.623630467],[165.396006707,-21.620538019],[165.290782097,-21.576755467],[165.277028842,-21.56617604],[165.268809441,-21.552666925],[165.259532097,-21.521172784],[165.25684655,-21.515069269],[165.237966342,-21.512953383],[165.22559655,-21.507094008],[165.197764519,-21.487074477],[165.189707879,-21.485039972],[165.180674675,-21.484795831],[165.173513217,-21.483005467],[165.17058353,-21.47649505],[165.156993035,-21.462172133],[165.153819207,-21.459730727],[165.116547071,-21.397719008],[165.114756707,-21.388360284],[165.118011915,-21.383396092],[165.118500196,-21.3788388],[165.111664259,-21.373142185],[165.109141472,-21.3710263],[165.102224155,-21.37118906],[165.093272332,-21.374444269],[165.087087436,-21.377618097],[165.087901238,-21.377211196],[165.084483269,-21.391371352],[165.075694207,-21.396091404],[165.066661004,-21.391208592],[165.061859571,-21.377211196],[165.054372592,-21.383396092],[165.046641472,-21.388360284],[165.03785241,-21.389418227],[165.026621941,-21.383965753],[165.045420769,-21.364678644],[165.043142123,-21.348077081],[165.027517123,-21.339125258],[165.005544467,-21.343031508],[165.013926629,-21.32805755],[165.009287957,-21.318047784],[164.985524936,-21.302015883],[164.976573113,-21.315524998],[164.979665561,-21.336602472],[164.971934441,-21.349867446],[164.961192254,-21.356052342],[164.951426629,-21.353773696],[164.943369988,-21.346286717],[164.937754754,-21.335625909],[164.941742384,-21.327732029],[164.942393425,-21.319105727],[164.945648634,-21.310479425],[164.951426629,-21.302015883],[164.943858269,-21.293389581],[164.936778191,-21.291273696],[164.929209832,-21.290215753],[164.920420769,-21.2850888],[164.914805535,-21.278741144],[164.907969597,-21.267347915],[164.834157748,-21.183282159],[164.829274936,-21.169528904],[164.827810092,-21.148125909],[164.828461134,-21.132419529],[164.82715905,-21.114678644],[164.81918379,-21.104099217],[164.800059441,-21.110284113],[164.801280144,-21.097263279],[164.802907748,-21.094170831],[164.80738366,-21.0897763],[164.80738366,-21.082289321],[164.800791863,-21.082207941],[164.796071811,-21.080661717],[164.786387566,-21.076267185],[164.792246941,-21.068536066],[164.791026238,-21.064385675],[164.78394616,-21.064385675],[164.772715691,-21.069431248],[164.770274285,-21.080987238],[164.758962436,-21.082452081],[164.749766472,-21.074802342],[164.745941602,-21.059177342],[164.739593946,-21.05836354],[164.727305535,-21.060235284],[164.719248894,-21.065850519],[164.72543379,-21.076267185],[164.719004754,-21.083428644],[164.711761915,-21.0897763],[164.693369988,-21.0429013],[164.680674675,-21.023695571],[164.664073113,-21.014092706],[164.683278842,-21.001153253],[164.67457116,-20.992608331],[164.653575066,-20.98447031],[164.636729363,-20.97242604],[164.652517123,-20.971123956],[164.660817905,-20.9647763],[164.661875847,-20.955661717],[164.656586134,-20.945896092],[164.644216342,-20.939141534],[164.631358269,-20.937758071],[164.622813347,-20.9335263],[164.622406446,-20.9179013],[164.61622155,-20.9179013],[164.60059655,-20.927666925],[164.58497155,-20.920586847],[164.561045769,-20.898044529],[164.550547722,-20.895277602],[164.53003991,-20.894707941],[164.519379102,-20.89055755],[164.515147332,-20.885349217],[164.50261478,-20.8632138],[164.480316602,-20.85914479],[164.462412957,-20.848565363],[164.418793165,-20.806247654],[164.388926629,-20.787367446],[164.375498894,-20.774021092],[164.365570509,-20.758070571],[164.372080925,-20.757256769],[164.386892123,-20.759698175],[164.402679884,-20.754082941],[164.410411004,-20.738457941],[164.404307488,-20.725355727],[164.38965905,-20.716403904],[164.372080925,-20.713067316],[164.357188347,-20.702325128],[164.335134311,-20.655450128],[164.316742384,-20.644789321],[164.286631707,-20.575860284],[164.281016472,-20.579522394],[164.2763778,-20.580498956],[164.271739129,-20.581149998],[164.266123894,-20.582696222],[164.256032748,-20.565036717],[164.192556186,-20.525811456],[164.177419467,-20.50400156],[164.165863477,-20.463067316],[164.163747592,-20.44898854],[164.158702019,-20.432549738],[164.146983269,-20.425062758],[164.133474155,-20.420098566],[164.123383009,-20.410821222],[164.118662957,-20.390313409],[164.130137566,-20.388116144],[164.156993035,-20.397149347],[164.166514519,-20.3866513],[164.170420769,-20.369724217],[164.17058353,-20.339125258],[164.166514519,-20.33212656],[164.156260613,-20.319024347],[164.143809441,-20.306573175],[164.132497592,-20.300957941],[164.085459832,-20.298760675],[164.073741082,-20.294122003],[164.080414259,-20.280938409],[164.081228061,-20.267836196],[164.074880405,-20.261163019],[164.060720248,-20.266778253],[164.064952019,-20.276788019],[164.059336785,-20.288018488],[164.04948978,-20.297133071],[164.040212436,-20.300957941],[164.025401238,-20.297051691],[164.020762566,-20.287774347],[164.018077019,-20.278497003],[164.009532097,-20.274183852],[163.99480228,-20.264255467],[163.998220248,-20.244561456],[164.016612175,-20.231052342],[164.047129754,-20.239434503],[164.056407097,-20.227634373],[164.052500847,-20.215508722],[164.033457879,-20.192315363],[164.045176629,-20.18759531],[164.052500847,-20.177829685],[164.05372155,-20.164971613],[164.047129754,-20.151462498],[164.032237175,-20.140313409],[164.020274285,-20.142347915],[164.007660352,-20.148858331],[163.991953972,-20.151462498],[163.991953972,-20.143812758],[163.997080925,-20.139825128],[164.000336134,-20.135349217],[164.005544467,-20.123467706],[163.99105879,-20.118910415],[163.986013217,-20.109633071],[163.98715254,-20.097263279],[163.991953972,-20.083103123],[163.999685092,-20.084161066],[164.013519727,-20.083103123]]],[[[164.224619988,-20.137627863],[164.240244988,-20.158298435],[164.221039259,-20.153497003],[164.192637566,-20.139092706],[164.169200066,-20.123304946],[164.164317254,-20.105075779],[164.163747592,-20.061944269],[164.17058353,-20.061944269],[164.215017123,-20.117852472],[164.224619988,-20.137627863]]],[[[163.985362175,-20.066664321],[163.982920769,-20.075290623],[163.978200717,-20.083103123],[163.97136478,-20.068780206],[163.956390821,-20.073663019],[163.947113477,-20.066013279],[163.937266472,-20.041599217],[163.937266472,-20.033949477],[163.94410241,-20.025974217],[163.949717644,-20.002211196],[163.957692905,-19.99993255],[163.967133009,-20.008070571],[163.975108269,-20.035414321],[163.985118035,-20.047621352],[163.986094597,-20.057549738],[163.985362175,-20.066664321]]],[[[163.696136915,-19.765069269],[163.669688347,-19.787692967],[163.639984571,-19.723728123],[163.636078321,-19.701592706],[163.637868686,-19.660577081],[163.632334832,-19.645928644],[163.615733269,-19.636163019],[163.621836785,-19.623711847],[163.637950066,-19.631768488],[163.649668816,-19.646254165],[163.670176629,-19.693291925],[163.677093946,-19.725518488],[163.682790561,-19.739841404],[163.693858269,-19.757500909],[163.696136915,-19.765069269]]],[[[159.955577019,-19.328301691],[159.938243035,-19.337172133],[159.930918816,-19.325290623],[159.926117384,-19.187676691],[159.934580925,-19.137953383],[159.955577019,-19.10914479],[159.972666863,-19.135023696],[159.979828321,-19.174086196],[159.978282097,-19.21493906],[159.969248894,-19.246351821],[159.969248894,-19.292250258],[159.965505405,-19.31226979],[159.955577019,-19.328301691]]]]}";

    when(record.get(GeoCsvField.gid)).thenReturn("1004051");
    when(record.get(GeoCsvField.locality)).thenReturn("New Caledonia");
    when(record.get(GeoCsvField.geojson)).thenReturn(geoJson);
    when(record.get(GeoCsvField.iso)).thenReturn("NCL");
    when(record.get(GeoCsvField.source)).thenReturn("World Countries");
    when(record.get(GeoCsvField.type)).thenReturn("Country");
    when(record.get(GeoCsvField.country_nl)).thenReturn("Nieuw-Caledonië");

    GeoTransformer geoTransformer = new GeoTransformer(report, etlStatistics);

    CommonReflectionUtil.setField(AbstractTransformer.class, geoTransformer, "objectID", "1004051");
    CommonReflectionUtil.setField(AbstractTransformer.class, geoTransformer, "input", record);

    Object returned =
        CommonReflectionUtil.callMethod(null, CSVRecordInfo.class, geoTransformer, "doTransform");

    List<GeoArea> list = (List<GeoArea>) returned;

    GeoArea actual = list.get(0);

    String expectedId = "1004051@GEO";
    String expectedAreaType = "Country";
    String expectedLocaity = "New Caledonia";
    String expectedSource = "World Countries";
    String expectedIso = "NCL";

    assertNotNull(actual);
    assertTrue(list.size() == 1);
    assertEquals("01", expectedId, actual.getId());
    assertEquals("02", expectedAreaType, actual.getAreaType());
    assertEquals("03", expectedLocaity, actual.getLocality());
    assertEquals("04", expectedSource, actual.getSource());
    assertEquals("05", expectedIso, actual.getIsoCode());
  }
}
